
/*
 ******************************************
 **    © by Widgetschmie.de 2005-2008    **
 ******************************************
 */

var wasBTRequest = false;
var btSupport = '0';
var btStatus = 'notAvailable';			// can be notAvailable, available, activated, connected
var btDeviceConnnected = '0';


function checkBTAvailability()
{
	if(! window.widget)
		return;
	
	var bt_style = getObj('bluetoothSwitch').style;
	
	if (FernsehPlugin.canUseBluetooth())
	{
		if(!isCollapsed()) {
			bt_style.display = 'block';
			bt_style.opacity = 1;
		}
		if ("1" == btDeviceConnnected) {
			bt_style.backgroundImage = "url(Images/BT_connected.png)";
			btStatus = 'connected';
		}
		else {
			bt_style.backgroundImage = ("1" == btSupport) ? "url(Images/BT_activated.png)" : "url(Images/BT_available.png)";
			btStatus = ("1" == btSupport) ? 'activated' : 'available';
		}
	}
	else {
		if ("1" == btSupport)
		{
			FernsehPlugin.setBTEnabled(false);
		}
		btSupport = "0";
		btStatus = 'notAvailable';
		btDeviceConnnected = "0";
		bt_style.backgroundImage = "url(Images/BT_notAvailable.png)";
	}
}

function toggleBluetooth()
{
	checkBTAvailability();
	if (("0" == btSupport) && !FernsehPlugin.canUseBluetooth()) 
	{
		FernsehPlugin.beep();
		return;
	}
	if ("0" == btSupport)
	{
		FernsehPlugin.setBTEnabled(true);
	} else {
		FernsehPlugin.setBTEnabled(false);
	}
	// bluetoothServerRunning is being called from the plugin
	// no need to set any variables here
}

function bluetoothServerRunning(flag)
{
	btSupport = flag;
	checkBTAvailability();
	widget.setPreferenceForKey(flag, "BluetoothSupport");
}

function btConected(flag)
{
	btDeviceConnnected = flag;
	checkBTAvailability();
	if (!btDeviceConnnected) wasBTRequest = false;
}

function btRequest(request)
{
	//alert("btrequest: "+request);

	if ((request.length > 2) && (request.substr(0,2) == ">="))
	{
		// remote control for EyeTV
		if ("eyetv" == tunerUsed) return;
		if (!tunerIsRunning()) return;
		var tmp = request.substr(2, request.length-2);
		
		var appls = "";
		
		if (tmp == "STAR") appls = "\nif full screen then\nexit full screen\nreturn\nend if\nenter full screen\nend tell";
		if (tmp == "3") appls = " to volume_up";
		if (tmp == "9") appls = " to volume_down";
		if (tmp == "0") appls = " to playpause";
		if (tmp == "1") appls = " to skip backward";
		if (tmp == "7") appls = " to skip forward";
		if (tmp == "POUND") appls = " to quit";

		if ("" != appls) FernsehPlugin.appleScript('tell application "' + tvAppName + '"' + appls);
		
		return;
	}
	if ((request.length > 2) && (request.substr(0,2) == ">>"))
	{
		var channel = request.substr(2, request.length-2);
		directlySwitchTVToChannel(channel);
		return;
	}
	if ((request.length > 2) && (request.substr(0,2) == ">W"))
	{
		var url = request.substr(2, request.length-2);
		openURL(url);
		return;
	}
	if ((request.length > 2) && (request.substr(0,2) == ">#"))
	{
		var toggle = request.substr(2, request.length-2);
		toggleAlarmForShowWithID(toggle);
		return;
	}
	wasBTRequest = true;

	if ((request.length > 2) && (request.substr(0,2) == ">+"))
	{
		var req = request.substr(2, request.length-2);
		getShowDescription(req, undefined);
		return;
	}
	if ((request.length > 2) && (request.substr(0,2) == ">?"))
	{
		var req = request.substr(2, request.length-2);
		getObj("searchInput").value = req;
		immediateSearch(req);
		return;
	}

	if (isCollapsed())
	{
		toggleWidget();
	}
	
	if ("FilteredShows" == request)
	{
		displaySpecialContent('filtered');
		return;
	}
	if ("Alarms" == request)
	{
		displaySpecialContent('alerts');
		return;
	}

	if ("next" == request)
	{
		showNext();
		return;
	}
	if ("previous" == request)
	{
		showPrevious();
		return;
	}
	
	var options = request.split("|");
	
	var day = options[0];
	var hour = options[1];
	var channel = options[2];
	
	var group = 1;
	if ("two" == options[2]) group = 2;
	displaySetting['channelsOfGroup'] = group;
	
	displaySetting['day'] = Math.abs(options[0]);
	
	displaySetting['time'] = "now";
	displaySetting['timestamp'] = 0;
	if ("primetime" == options[1]) 
	{
		displaySetting['time'] = "primetime";
		var the_time = new Date();
		the_time.setSeconds(0);
		the_time.setMilliseconds(0);
		the_time.setHours(20);
		the_time.setMinutes("CH" == currentLocale() ? 0 : 15);
		if (displaySetting['day'] > 0) {
			the_time.setDate(the_time.getDate() + 1* displaySetting['day']);
		}
		the_time = the_time.getTime();
		displaySetting['timestamp'] = the_time;
	}
	
	if (2 == displaySetting['channelsOfGroup']) {
		channels = channelGroup2;
	}
	else if (1 == displaySetting['channelsOfGroup']) {
		displaySetting['channelsOfGroup'] = 1;
		channels = channelGroup1;
	}
	displaySetting['genre'] = ''; // all of them
	displaySetting['mode'] = 'single';
	
	updateTVListing();
}

function toggleAlarmForShowWithID(showid)
{
	if (FernsehPlugin.alarmExistsForShow(showid)) FernsehPlugin.removeAlarmForShow(showid);
	else FernsehPlugin.setAlarmForShow(showid);
}

function sendBluetoothShows(shows)
{
	var separator = "{-----}"
	var result = "" + shows.length + separator;
	
	// show titles
	for (var i = 0; i < shows.length; i++)
	{
		result += shows[i].title + separator;
	}
	
	// the channels
	for (var i = 0; i < shows.length; i++)
	{
		result += (availableChannels[shows[i].channel]).getName() + separator;
	}
	
	// the start time (yup, as string, display pursposes only)
	for (var i = 0; i < shows.length; i++)
	{
		var date = new Date();
		date.setTime(Math.abs(shows[i].startstamp));
		var hours = date.getHours();
		var minutes = date.getMinutes();
		if (hours < 10) result += "0";
		result+= hours + ":";
		if (minutes < 10) result += "0";
		result += minutes;
		result += separator;
	}
	
	// description
	for (var i = 0; i < shows.length; i++)
	{
		var length = shows[i].duration + " Minuten\n\n";
		var description = locStr("Keine Beschreibung vorhanden");
		if ("" != shows[i].moreInfo) description = shows[i].moreInfo;
		//description = description.replace(/<br>/g, "\n");
		result += length + description + separator;
	}
	
	// tuner channel
	for (var i = 0; i < shows.length; i++)
	{
		var tuner = (availableChannels[shows[i].channel]).getTuner();
		if ("" == tuner) tuner = " "; // that's the way the j2me app wants it.
		result +=  tuner + separator;
	}
	
	// how much of the show has elapsed
	for (var i = 0; i < shows.length; i++)
	{
		if (0 == shows[i].fractionDone)
		{
			// show hasn't yet begun
			// + alarm set
			// - no alarm set
			if (FernsehPlugin.alarmExistsForShow(shows[i].coredataID))
			{
				result += "+" + shows[i].coredataID + separator;
			} else {
				result += "-" + shows[i].coredataID + separator;
			}
		} else if (1 < shows[i].fractionDone)
		{
			// show is over
			result += " " + separator;
		} else {
			// show is running
			result += ((""+(shows[i].fractionDone*100)).split("."))[0] + separator;
		}
	}
	
	// the date of the show (relevant for search results, alarms, filter results)
	for (var i = 0; i < shows.length; i++)
	{
		var date = new Date();
		date.setTime(shows[i].startstamp);
		result += printableDate(date) + separator;
	}
	
	// the more info stuff
	for (var i = 0; i < shows.length; i++)
	{
		var descurl = " ";
		result += (undefined == descurl ? " " : descurl) + separator;
	}
	//alert(result);
	FernsehPlugin.takeBTShows(result);
	wasBTRequest = false;
}


// GUI
function btToggleOver() {
	if('available' == btStatus) {
		getObj('bluetoothSwitch').style.backgroundImage = "url(Images/BT_hover.png)";
	}
}

function btToggleOut() {
	getObj('bluetoothSwitch').style.backgroundImage = "url(Images/BT_" + btStatus + ".png)";
}
