
/*
 ******************************************
 **    © by Widgetschmie.de 2005-2008    **
 ******************************************
 */


var displaySetting = new Object();
displaySetting['channelsOfGroup'] = 1;		// 0 = none, 1 = group-1, 2 = group-2, 3 = both groups
displaySetting['channels'] = '';			// a string(!!!) that holds the ids of all channels to be displayed, separated by \n
displaySetting['day'] = '0';				// 0 = today, 1 = tomorrow, ...
displaySetting['time'] = 'now';				// now, primetime, 1:00, 2:15, ...
displaySetting['timestamp'] = null;			// timestamp of the first show with offset 0
displaySetting['offset'] = 0;				// display shows from this offset, which match the other settings
displaySetting['mode'] = 'single';			// single, grouped, magazine		(!!) will be overridden once adjustPrefs() got called from loaded()
displaySetting['genre'] = '';				// The name of any genre, "" for all genres
displaySetting['numShowsPerGroup'] = 4;		// the number of shows to show per channel (in grouped mode)	(!!) will be overridden once adjustPrefs() got called from loaded()

var LANG = 'de';
var LOCALE = 'DE';

var firstShowStamp = new Date();			// holds the timestamp of the first show of the page or is = now in magazine-view
var previouslyShownChannelGroup = 1;		// needed when we switch to a channel-only view and want to switch back to where we were
var magazineViewStartHour = 5;
var magazineViewScaleFactor = 3;			// will be calculated from mainFontSize

var specialDisplayShown = false;			// if set to a string, help, all alerts, all filters or actor-shows are displayed on front
var isSearchResult = false;
var ourSearchString = '';
var possibleSearchOptions = new Array("title", "description", "director", "actors");		// all possible search options
var searchOptions = new Array("title", "actors");											// currently active search options

var debugMode = false;

var refreshBlocked = false;
var releaseRefreshBlock = true;

var needsToCheckCache = true;
var lastCacheCheckDate;
var weMayCache = true;


// set it on fire!
function loaded()
{
	try {
		if(!FernsehPlugin) {
			showDialog("The Plugin could not be loaded<br />Try to delete the Cache in ~/Library/ApplicationSupport/Fernsehen/", "OK", blendDialogOut);
			return;
		}
	}
	catch(exc) {
		showDialog("The Plugin could not be loaded<br />Try to delete the Cache in ~/Library/ApplicationSupport/Fernsehen/", "OK", blendDialogOut);
		return;
	}
	
	LANG = systemLang();
	LOCALE = currentLocale();
	lastCacheCheckDate = new Date();
	
	// preload some images
	var img = new Image();
	img.src = "Images/searchOptions_hover.png";
	img.src = "Images/searchOptions_active.png";
	
	// the widget version
	_version = getCurrentVersion();
	if(getObj('thisVersion')) {
		getObj('thisVersion').innerHTML = getBeautifulVersionnumber(_version);
	}
	
	// load the channels
	loadAllChannels();			// this function also loads the channels into the <select> - menus
	
	// LOAD PREFS
	adjustPrefs();
	displaySetting['mode'] = savedMode ? savedMode : displaySetting['mode'];
	activeSwitchControlButton = switchControlButtonForMode[displaySetting['mode']];
	displaySetting['numShowsPerGroup'] = savedNumShowsPerGroup ? savedNumShowsPerGroup : displaySetting['numShowsPerGroup'];
	switchToPrefSection("general");
	setTimeout("localizePrefs()", 10);
	
	// Setup Scroller, Drawer and controls
	showInDrawer();
	scrollerInit('myScrollBar', getObj("myScrollBar"), getObj("myScrollTrack"), getObj("myScrollThumb"));
	scrollerInit('myDrawerScrollBar', getObj("myDrawerScrollBar"), getObj("myDrawerScrollTrack"), getObj("myDrawerScrollThumb"));
	setTimeout("initControlBar()", 10);
	
	// add event handlers
	if(window.widget) {
		widget.onshow = onShow;
		widget.onhide = onHide;
		
		// resize the widget
		var winX = widget.preferenceForKey("windowX");
		var winY = widget.preferenceForKey("windowY");
		if((undefined != winX) && (undefined != winY)) {
			window.resizeTo(winX, winY);
		}
		
		if(widget.preferenceForKey("isCollapsed")) {
			widgetAnim.expandedHeight = winY;
			collapseImmediately();
		}
	}
	
	// DO IT!!
	setTimeout("initToolbar('standard')", 10);
	setTimeout("setupToolbarGenres()", 10);
	setTimeout("updateFilterBadge()", 20);
	setTimeout("reallyLoaded()", 100);			// put everything which needs channelsLoaded to be TRUE in there
	setTimeout("checkLatestVersion()", 200);
	
	// Bluetooth
	if(window.widget) {
		var bttemp = widget.preferenceForKey("BluetoothSupport");
		if (undefined != bttemp) btSupport = bttemp;
		if (!FernsehPlugin.canUseBluetooth() && "1" == btSupport) btSupport = "0";
		
		if ("1" == btSupport) FernsehPlugin.setBTEnabled(true);
		
		setTimeout("checkBTAvailability()", 300);
	}
}

// depends on allChannelsLoaded() to successfully load the channels from the XML
function reallyLoaded() {
	if(channelsLoaded) {
		setTimeout("loadFilters()", 10);
		if(!isCollapsed()) {
			setTimeout("updateTVListing()", 30);
		}
		setTimeout("setChannelNamesInPlugin()", 50);
		setTimeout("cacheAhead()", 100);
	}
	else {
		alert("Channels are NOT yet loaded");
		setTimeout("reallyLoaded()", 500);
	}
}




// call this to display the desired shows. This will be called each time we click a toolbar item. force_starttime must be a timestamp (not a Date-Object)!
function updateTVListing(force_starttime)
{
	// das passiert wenn dem caching.js während des cachens bereits eine anfrage zum erneuten Darstellen geschickt wurde eben weil nicht alle
	// zur anzeige benötigten daten vorhanden sind.
	if(cachingInProgress && displaySetting['day'] >= currentlyCachingDay) {
		redisplayAfterCachingDay = displaySetting['day'];
		alert('UpdateTVListing not just yet, redisplayAfterCachingDay: ' + redisplayAfterCachingDay);
		startProgressAnim('mainProgress');
		return;
	}
	
	hideSpecialContent();
	
	var result = new Array();
	var channels;
	
	
	// channels
	if(0 == displaySetting['channelsOfGroup']) {
		channels = new Array("" + displaySetting['channels']);			// stupid JavaScript...
	}
	else if(3 == displaySetting['channelsOfGroup']) {
		channels = mergeArrays(channelGroup1, channelGroup2);
	}
	else if(2 == displaySetting['channelsOfGroup']) {
		channels = channelGroup2;
	}
	else {
		displaySetting['channelsOfGroup'] = 1;
		channels = channelGroup1;
	}
	
	if(!channels || (channels.length < 1)) {
		noResultFound();
		showDialog(locStr('Keine Sender definiert'), locStr('OK'), blendDialogOut, locStr('Sender zuweisen'), function() { blendDialogOut(); showPrefs(); switchToPrefSection('channels'); });
		return;
	}
	
	// start time and start day
	var the_time = new Date();
	the_time.setSeconds(0);
	the_time.setMilliseconds(0);
	
	if(force_starttime) {								// forced timestamp
		var today = new Date();
		today.setMinutes(0);
		today.setHours(0);
		displaySetting['day'] = (force_starttime - today.getTime()) / 86400000;
		the_time = force_starttime *1;
		
		var frce = new Date()
		frce.setTime(force_starttime);
		displaySetting['time'] = frce.getHours() + ":" + frce.getMinutes();
	}
	else {
		if('now' == displaySetting['time']) {					// NOW
			if(displaySetting['day'] > 0) {
				the_time.setDate(the_time.getDate() + (1* displaySetting['day']));
				the_time = the_time.getTime();
			}
			else {
				the_time = 0;
			}
		}
		else if('primetime' == displaySetting['time']) {		// Primetime
			the_time.setHours(20);
			the_time.setMinutes("CH" == currentLocale() ? 0 : 15);
			if(displaySetting['day'] > 0) {
				the_time.setDate(the_time.getDate() + 1* displaySetting['day']);
			}
			the_time = the_time.getTime();
		}
		else {
			the_time = the_time.getTime();
		}
	}
	
	
	// Check if we got the desired data
	if(needsToCheckCache && (!hasDataForChannels(channels, displaySetting['day'])))
	{
		redisplayAfterCachingDay = 1*displaySetting['day'];
		
		setTimeout("cacheAhead()", 10);
		needsToCheckCache = false;
		lastCacheCheckDate = new Date();
		
		return;
	}
	
	redisplayAfterCachingDay = -2;
	
	displaySetting['timestamp'] = the_time;
	displaySetting['channels'] = channels.join("\n");
	displaySetting['offset'] = 0;
	
	displayShowsCD();
	toolbarUpdate();
	controlButtonUpdate();
}




function immediateSearch(searchString)
{
	if (isCollapsed()) toggleWidget();
	hideSpecialContent();
	
	displaySetting['offset'] = 0;
	if(searchString == "") {
		updateTVListing();
		return;
	}
	
	if(displaySetting['channelsOfGroup'] < 1) {
		displaySetting['channelsOfGroup'] = 1;
		displaySetting['channels'] = channelGroup1;
	}
	
	displayShowsCD(searchString);
}



// Main function to display the shows
function displayShowsCD(extra_string)
{
	purgeParagraphs();
	lastParagraphIndex = 0;
	var highlightedShowFound = false;
	var enableNextShowsArrow = false;
	var enablePrevShowsArrow = false;
	var shows = new Array();

	var content = getObj('content');
	content.style.top = '';
	content.style.left = '';
	content.style.width = null;
	
	// Special headers
	if(0 == displaySetting['channelsOfGroup']) {
		addChannelHeader(displaySetting['channels'], new Array('closeButton'));
	}
	
	
	// ****
	// search result, filters, alerts or shows per person
	isSearchResult = false;
	ourSearchString = '';
	
	if(extra_string) {
		displaySetting['offset'] = displaySetting['offset'] < 0 ? 0 : displaySetting['offset'];
		changeDisplayMode('single', true);
		var showids = new Array();
		
		// alerts
		if('alerts' == extra_string) {
			showids = FernsehPlugin.timers();
		}
		
		// filters
		else if('filtered' == extra_string) {
			showids = FernsehPlugin.filteredShows();
		}
		
		// shows of the selected person (actor/regisseur)
		else if ('person_' == extra_string.substr(0, 7)) {
			showids = FernsehPlugin.showsWithActorOrDirector(extra_string.substr(7));
		}
		
		// SEARCH
		else {
			isSearchResult = true;
			ourSearchString = extra_string;
			var search_in = '';
			if(searchOptions) {
				search_in = searchOptions.join("|");
			}
			if(search_in.length < 1) {
				search_in = "titel|actors";
			}
			showids = FernsehPlugin.searchShowsOnChannels(extra_string, "", displaySetting['offset'], numEntriesPerPage, displaySetting['genre'], search_in);
			
			enableNextShowsArrow = FernsehPlugin.hasMoreShows();
		}
		
		
		// Determine the offset and which arrows to show
		if(!isSearchResult && showids) {
			if(showids.length > numEntriesPerPage) {
				if(displaySetting['offset'] > 0) {
					displaySetting['offset'] = numEntriesPerPage * Math.floor(showids.length / numEntriesPerPage);
				}
				else if(displaySetting['offset'] < 0) {
					displaySetting['offset'] = 0;
				}
				
				enableNextShowsArrow = (showids.length > displaySetting['offset'] + 1* numEntriesPerPage);
				showids = showids.slice(displaySetting['offset'], displaySetting['offset'] + 1* numEntriesPerPage);
			}
			else {
				displaySetting['offset'] = 0;
			}
		}
		enablePrevShowsArrow = (displaySetting['offset'] > 0);
		
		shows = showsFromIDs(showids);
		
		// no shows found
		if(!shows || (shows.length < 1)) {
			noResultFound(isSearchResult);
			controlButtons["previousShows"].disable();
			controlButtons["nextShows"].disable();
			
			if (wasBTRequest) FernsehPlugin.takeBTShows("0");
			wasBTRequest = false;
			return;
		}
	}
	
	
	// ****
	// List mode
	if('single' == displaySetting['mode']) {
		if(!shows || (shows.length < 1)) {
			shows = showsFromIDs(FernsehPlugin.showsOnChannel(displaySetting['channels'], displaySetting['timestamp'], displaySetting['offset'], numEntriesPerPage, displaySetting['genre']));
		}
		highlightedShowFound = showSingle(shows);
		
		if(!extra_string) {
			enablePrevShowsArrow = FernsehPlugin.canGoBack();
			enableNextShowsArrow = FernsehPlugin.hasMoreShows();
		}
		
		// previous shows arrow
		if(enablePrevShowsArrow) {
			controlButtons["previousShows"].enable();
		}
		else {
			controlButtons["previousShows"].disable();
		}
		
		// next shows arrow
		if(enableNextShowsArrow) {
			controlButtons["nextShows"].enable();
		}
		else {
			controlButtons["nextShows"].disable();
		}
		
		calculateAndShowThumb('myScrollBar', content);
	}
	
	// ****
	// Grouped mode
	else if('grouped' == displaySetting['mode']) {
		highlightedShowFound = showGrouped();
		controlButtons["nextShows"].disable();
		controlButtons["previousShows"].disable();
		calculateAndShowThumb('myScrollBar', content);
	}
	
	// ****
	// Magazine view
	else if('magazine' == displaySetting['mode']) {
		highlightedShowFound = showMagazineView();
		
		if(FernsehPlugin.hasMoreShows()) {
			controlButtons["nextShows"].enable();
		}
		else {
			controlButtons["nextShows"].disable();
		}
		
		if(FernsehPlugin.canGoBack()) {
			controlButtons["previousShows"].enable();
		}
		else {
			controlButtons["previousShows"].disable();
		}
	}
	
	redrawElapsed();
	stopProgressAnim("mainProgress");
	if(!isSearchResult) {
		getObj("searchInput").value = "";
	}
	
	// close the drawer when the selected show is not in the view
	if(!highlightedShowFound) {
		resizeDrawer('close');
	}
	
	if(wasBTRequest) {
		sendBluetoothShows(shows);
	}
}


// display the list
function showSingle(shows)
{
	var highlightedShowFound = false;
	var firstDateSet = false;
	var thisLastDay, thisDay, thisDate;
	
	if(!shows || (shows.length < 1)) {
		noResultFound(isSearchResult);
	}
	else {
		for (var i = 0; i < shows.length; i++)
		{
			thisDate = new Date(shows[i].startstamp);
			thisDay = thisDate.getDate();
			
			// set the date of the first show in the title
			if(!firstDateSet) {
				displayTitle(dayAndDate(thisDate));
				firstDateSet = true;
				thisLastDay = thisDay;
				firstShowStamp = thisDate;
			}
			
			// day-header
			if(thisDay != thisLastDay) {
				thisLastDay = thisDay;
				addDateHeader(thisDate);
			}
			
			shows[i].display();
			
			if(!highlightedShowFound) {
				highlightedShowFound = (lastActiveShow == shows[i].coredataID);
			}
		}
	}
	
	return highlightedShowFound;
}

function showGrouped()
{
	var highlightedShowFound = false;
	var firstDateSet = false;
	var shows = showsFromIDs(FernsehPlugin.groupedShowsOnChannels(displaySetting['channels'], displaySetting['timestamp'], displaySetting['numShowsPerGroup']));
	
	if(!shows || (shows.length < 1)) {
		noResultFound();
	}
	else {
		var channel;
		for (var i = 0; i < shows.length; i++)
		{
			// set the date of the first show in the title
			if(!firstDateSet) {
				var thisDate = new Date();
				thisDate.setTime(shows[i].startstamp);
				displayTitle(dayAndDate(thisDate));
				firstDateSet = true;
				firstShowStamp = thisDate;
			}
			
			// set the channel header
			if(channel != shows[i].channel) {
				addChannelHeader(shows[i].channel, new Array('minusButton', 'plusButton'));
				channel = shows[i].channel;
			}
			
			shows[i].display();
			
			if(!highlightedShowFound) {
				highlightedShowFound = (lastActiveShow == shows[i].coredataID);
			}
		}
	}
	
	return highlightedShowFound;
}


// this is called by displayShowsCD when we want the magazine view
function showMagazineView() {
	var highlightedShowFound = false;
	
	firstShowStamp = new Date();
	if(firstShowStamp.getHours() < magazineViewStartHour) {
		firstShowStamp.setDate(firstShowStamp.getDate() - 1);
	}
	firstShowStamp.setDate(firstShowStamp.getDate() + 1*displaySetting['day']);
	firstShowStamp.setHours(magazineViewStartHour);		firstShowStamp.setMinutes(30);		firstShowStamp.setSeconds(0);		firstShowStamp.setMilliseconds(0);
	var morning_stamp = firstShowStamp.getTime();
	var shows = showsFromIDs(FernsehPlugin.showsOnChannelsFromTo(displaySetting['channels'], morning_stamp, morning_stamp + 86400000));		// 86'400'000 = ms of one day
	
	if(!shows || (shows.length < 1)) {
		noResultFound();
	}
	else {
		_now = new Date();
		_now.setSeconds(0);			_now.setMilliseconds(0);
		
		var channel;
		var channel_count = 0;
		var content = getObj('content');
		var parentline = null;
		var firstDateSet = false;
		magazineViewScaleFactor = Math.floor(mainFontSize / 6);
		
		// add HOUR separators
		for(var i = 1; i <= 24; i++) {
			var hour = firstShowStamp.getHours() + i;
			
			var div = document.createElement('div');
			div.setAttribute('id', "magazineHourIndicator_" + i);
			div.setAttribute('class', "magazineHourIndicator" + ((0 == i % 2) ? '' : " magazineHourIndicatorAltCol"));
			div.style.height = (60 * magazineViewScaleFactor) + "px";
			div.style.top = ((((hour - firstShowStamp.getHours()) * 60) - 30) * magazineViewScaleFactor) + "px";
			div.innerHTML = (((hour % 24) < 10) ? '0' : '') + (hour % 24) + ":00";
			content.appendChild(div);
		}
		
		// channel HEADER container and SIDEWAYS scroller
		var headercontainer = document.createElement('div');
		headercontainer.setAttribute('id', "magazineChannelContainer");
		content.appendChild(headercontainer);
		
		var scrollright = document.createElement('div');
		scrollright.setAttribute('id', "scrollRight");
		scrollright.setAttribute('onmouseover', "scrollElemRight('content')");
		scrollright.setAttribute('onclick', "scrollElemRight('content', true)");
		scrollright.setAttribute('onmouseout', "stopSidewaysScroll()");
		scrollright.style.left = (content.parentNode.offsetWidth - 30 - 8) + 'px';			// 30px is the scroller width, 8px the area covered by the scrollbar
		
		var scrollleft = document.createElement('div');
		scrollleft.setAttribute('id', "scrollLeft");
		scrollleft.setAttribute('onmouseover', "scrollElemLeft('content')");
		scrollleft.setAttribute('onclick', "scrollElemLeft('content', true)");
		scrollleft.setAttribute('onmouseout', "stopSidewaysScroll()");
		scrollleft.style.display = 'none';
		
		headercontainer.appendChild(scrollright);
		headercontainer.appendChild(scrollleft);
		
		
		// LOOP ALL SHOWS ******
		for(var i = 0; i < shows.length; i++) {
			// set the date of the first show in the title
			if(!firstDateSet) {
				displayTitle(dayAndDate(firstShowStamp));
				firstDateSet = true;
			}
			
			// new channel ROW
			if(channel != shows[i].channel) {
				if(parentline) {
					content.appendChild(parentline);
				}
				
				parentline = document.createElement("div");
				parentline.setAttribute("class", "magazineChannel");
				parentline.style.height = (24 * 60 * magazineViewScaleFactor) + 2 + "px";		// +2 compensates for the borders
				channel = shows[i].channel;
				
				// channel label
				var label = document.createElement("div");
				label.setAttribute("class", "magazineChannelName");
				label.innerHTML = "<span>" + (availableChannels[channel] ? availableChannels[channel].getName() : channel) + "</span>";
				headercontainer.appendChild(label);
				
				channel_count++;
			}
			
			// add the show
			var dom = shows[i].getMagazineRow(firstShowStamp);
			if(dom && parentline) {
				parentline.appendChild(dom);
			}
			
			if(!highlightedShowFound) {
				highlightedShowFound = (lastActiveShow == shows[i].coredataID);
			}
		}
		
		// append last channel
		content.appendChild(parentline);
		content.style.width = (8 * channel_count) + 1 + "em";		// The +1 prevents the last sender-column to be covered by the scrollbar
		
		scrollMagazineViewTo(displaySetting['time'], true);
	}
	
	return highlightedShowFound;
}



function noResultFound(from_search) {
	purgeParagraphs();
	getObj("content").style.top = "0px";
	getObj("content").innerHTML = "<div class=\"nothingFound\">" + (from_search ? locStr("Keine Sendung gefunden") : locStr("Keine entsprechende Sendung")) + "</div>";
	calculateAndShowThumb('myScrollBar', getObj("content"));
	displayTitle("Fernsehen");
}



function changeToChannelOnlyView(channel_id, startstamp)
{
	previouslyShownChannelGroup = displaySetting['channelsOfGroup'];
	displaySetting['channelsOfGroup'] = 0;
	displaySetting['channels'] = channel_id;
	displaySetting['previousDisplaySettingStartTime'] = displaySetting['time'];
	updateTVListing(startstamp);
}

function changeDisplayMode(newMode, no_update) {
	if(displaySetting['mode'] == newMode) {
		return;
	}
	
	displaySetting['mode'] = newMode;
	
	// adjust control buttons
	controlButtonUpdate();
	
	// apply (and save in prefs)
	widget.setPreferenceForKey(newMode, "savedMode");
	if(!no_update) {
		updateTVListing();
	}
}

function changeNumGrouped(by) {
	var newNum = displaySetting['numShowsPerGroup'] + by;		// variable 'by' can of coure be negative
	newNum = ((newNum > 0) && (newNum < 100)) ? newNum : 4;
	
	// to later scroll to where we were, save the click-position
	var clicked_id = null;
	var top_offset = 0;
	if(window.event) {
		clicked_id = event.target.id;				// since updateTVListing() removes all elements, we need this to get the new instance of the clicked button
		top_offset = event.target ? (event.target.parentNode.parentNode.offsetTop - (-1 * parseInt(getObj('content').style.top))) : 0;		// visible offset of clicked header
	}
	
	// apply (and save in prefs)
	displaySetting['numShowsPerGroup'] = newNum;
	widget.setPreferenceForKey(newNum, "savedNumShowsPerGroup");
	updateTVListing();
	
	// scroll the window to where we were
	if(top_offset > 0) {
		var obj = getObj(clicked_id);
		if(obj) {
			var surplus = obj.parentNode.parentNode.offsetTop - top_offset;
			surplus = (surplus < 0) ? 0 : -1 * surplus;
			getObj('content').style.top = surplus + "px";
		}
	}
	
	calculateAndShowThumb('myScrollBar', getObj('content'));
}



function showError()
{
	hideDrawer();
	showDialog(locStr("Netzwerkfehler"), locStr("Ignorieren"), blendDialogOut, locStr("Netzwerk-Diagnose..."), openDiagnosis);
}


function openURL(url)
{
	refreshBlocked = true;
	widget.openURL(url);
}


function purgeParagraphs()
{
	cleanNode('content');
}


function showPrevious()
{
	if('magazine' == displaySetting['mode']) {
		displaySetting['day'] -= 1;
	}
	else {
		displaySetting['offset'] -= numEntriesPerPage;
	}
	
	if(specialDisplayShown) {
		displayShowsCD(specialDisplayShown);
	}
	else {
		displayShowsCD(ourSearchString);
	}
	toolbarUpdate();
}

function showNext()
{
	if('magazine' == displaySetting['mode']) {
		displaySetting['day'] = 1*displaySetting['day'] + 1;
	}
	else {
		displaySetting['offset'] += numEntriesPerPage;
	}
	
	if(specialDisplayShown) {
		displayShowsCD(specialDisplayShown);
	}
	else {
		displayShowsCD(ourSearchString);
	}
	toolbarUpdate();
}


// initiate displaying special content    ----    help, alerts, filters
function displaySpecialContent(what) {
	specialDisplayShown = what;
	refreshBlocked = true;
	releaseRefreshBlock = false;
	
	blendDialogOut();
	hideDrawer();
	getObj("searchInput").value = "";
	initToolbar(what);
	controlButtonUpdate();
	getObj('filtercount').setAttribute('class', 'filterCount');
	
	// special handlig
	switch(what) {
		case 'help':		setTimeout("showHelp()", 10);
							getObj("controls").style.display = 'none';			break;
		case 'alerts':		setTimeout("showAlerts()", 10);						break;
		case 'filtered':	setTimeout("showFiltered()", 10);					break;
	}
}

function hideSpecialContent(do_refresh) {
	if(!specialDisplayShown)
		return;
	
	specialDisplayShown = false;
	refreshBlocked = false;
	releaseRefreshBlock = true;
	
	// re-show objects
	getObj('filtercount').setAttribute('class', 'filterCount');
	getObj("controls").style.display = 'block';
	
	// update listing
	displaySetting['genre'] = '';
	initToolbar('standard');
	if(do_refresh) {
		setTimeout("updateTVListing()", 10);
	}
}


function showAlerts()
{
	displaySetting['genre'] = "#showAlerts";
	displayShowsCD('alerts');
}

function showFiltered()
{
	displaySetting['genre'] = "#showFiltered";
	
	// update badge
	var badge = getObj('filtercount');
	if(badge) {
		badge.setAttribute('class', "filterCountActive");
	}
	
	displayShowsCD('filtered');
}

function showPersonShows(personID)
{
	initToolbar('personShows');
	specialDisplayShown = 'person_' + personID;
	displayShowsCD(specialDisplayShown);
}

function showHelp() {
	displaySetting['genre'] = "#showHelp";
	specialDisplayShown = 'help';
	
	if(prefsShown) {
		setTimeout("hidePrefs()", 10);
	}
	
	// fetch the help-text
	displayTitle(locStr("Hilfe und FAQ"));
	insertHelpText(locStr("Lade..."));
	var ajax = new simpleAjaxRequest(LANG + ".lproj/Help.html", insertHelpText, true);
	if(!ajax) {
		insertHelpText(locStr("Konnte Hilfe nicht laden"));
	}
}

function insertHelpText(text) {
	if(text) {
		var div = getObj('content');
		if(div) {
			div.innerHTML = "<div class=\"helpDiv\">" + text + "</div>";
		}
	}
	else {
		insertHelpText(locStr("Keine Hilfe verfügbar"));
	}
	
	setTimeout("calculateAndShowThumb('myScrollBar', getObj('content'))", 100);
}






function setDebugMode(flag)
{
	debugMode = flag;
	widget.setPreferenceForKey((flag ? "1" : "0"), "debugMode");
	if (debugMode) widget.system("/usr/bin/osascript -e 'tell application \"Console\" to activate'", null);
}


/*
 *******************
 * onShow + onHide *
 *******************
 */

function onShow()
{
	tunerIsCurrentlyPlaying = currentStation();
	
	// check the cache once a day and clean up old shows
	if (((new Date()).getTime() - lastCacheCheckDate.getTime()) > 86400000)
	{
		FernsehPlugin.cleanUpCD();
		cacheAhead();
		lastCacheCheckDate = new Date();
	}
	
	networkErrorOccurred = false;
	weMayCache = true;		// allows caching activities
	
	checkBTAvailability();
	if(!prefsShown) {
		playProgressAnim("mainProgress");
	}
	
	if (refreshBlocked)
	{
		if (releaseRefreshBlock)
		{
			refreshBlocked = false;
		}
		
		return;
	}
	FernsehPlugin.recacheScheduledShows();
	
	// determine if we do update the listing or if we don't
	if(("now" == displaySetting['time']) && (!dialogShown) && (!isSearchResult) && (!isCollapsed())) {
		updateTVListing();
	}
}

function onHide() {
	pauseProgressAnim("mainProgress");
	
	weMayCache = cacheInBackground;		// aborts all caching activities (unless "cacheInBackground" ist TRUE)
}

